/*****************************************************************************
* amf_usb_ioctl.h  Amfeltec USB Device Driver
* 		
* Copyright (C) 2013-2014, Amfeltec Corp.	
*****************************************************************************/

#ifndef AMF_USB_IOCTL_H
#define AMF_USB_IOCTL_H
#include <linux/ioctl.h>


#define AMF_MAX_CMD_DATA_SIZE 1000

typedef struct
{
	unsigned short	len;
	unsigned int	offset;
	unsigned char	bar;
	int				ret;
	int 			dev_num;
	int 			order;
	int 			amf_device_type;
	unsigned char	data[AMF_MAX_CMD_DATA_SIZE];
} amf_arg_t;


#define AMF_GET_STATUS _IOR('q', 1, amf_arg_t *)
#define AMF_GET_CPU_ID _IOR('q', 2, amf_arg_t *)
#define AMF_CPU_READ_REG _IOR('q', 3, amf_arg_t *)
#define AMF_CPU_WRITE_REG _IOWR('q', 4, amf_arg_t *)

#define AMF_FW_UPDATE_ENABLE _IOW('q', 5, amf_arg_t *)
#define AMF_FW_DATA_READ _IOR('q', 6, amf_arg_t *)
#define AMF_FW_DATA_WRITE _IOWR('q', 7, amf_arg_t *)

int exec_usb_cpu_read(int fd, int off, unsigned char *data, unsigned short len);
int exec_usb_fwupdate_enable(int fd);
int exec_usb_fw_data_write(int fd, unsigned char *data, unsigned short len);
int exec_usb_fw_data_read(int fd, unsigned char *data, unsigned short len);

#endif
